"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  WorkflowPlugin: true,
  triggers: true,
  useWorkflowVariableOptions: true
};
exports.default = exports.WorkflowPlugin = void 0;
Object.defineProperty(exports, "triggers", {
  enumerable: true,
  get: function get() {
    return _triggers.triggers;
  }
});
Object.defineProperty(exports, "useWorkflowVariableOptions", {
  enumerable: true,
  get: function get() {
    return _variable.useWorkflowVariableOptions;
  }
});
var _Branch = require("./Branch");
Object.keys(_Branch).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _Branch[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _Branch[key];
    }
  });
});
var _FlowContext = require("./FlowContext");
Object.keys(_FlowContext).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _FlowContext[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _FlowContext[key];
    }
  });
});
var _nodes = require("./nodes");
Object.keys(_nodes).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _nodes[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _nodes[key];
    }
  });
});
var _triggers = require("./triggers");
var _variable = require("./variable");
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
var _ExecutionPage = require("./ExecutionPage");
var _WorkflowPage = require("./WorkflowPage");
var _WorkflowProvider = require("./WorkflowProvider");
var _DynamicExpression = require("./components/DynamicExpression");
var _WorkflowTodo = require("./nodes/manual/WorkflowTodo");
var _WorkflowTodoBlockInitializer = require("./nodes/manual/WorkflowTodoBlockInitializer");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
class WorkflowPlugin extends _client().Plugin {
  load() {
    var _this = this;
    return _asyncToGenerator(function* () {
      _this.addRoutes();
      _this.addComponents();
      _this.app.use(_WorkflowProvider.WorkflowProvider);
    })();
  }
  addScopes() {
    this.app.addScopes({
      useCollectionDataSource: _client().useCollectionDataSource
    });
  }
  addComponents() {
    this.app.addComponents({
      WorkflowPage: _WorkflowPage.WorkflowPage,
      ExecutionPage: _ExecutionPage.ExecutionPage,
      WorkflowTodo: _WorkflowTodo.WorkflowTodo,
      WorkflowTodoBlockInitializer: _WorkflowTodoBlockInitializer.WorkflowTodoBlockInitializer,
      DynamicExpression: _DynamicExpression.DynamicExpression
    });
  }
  addRoutes() {
    this.app.router.add('admin.settings.workflow.workflows.id', {
      path: '/admin/settings/workflow/workflows/:id',
      element: _react().default.createElement(_WorkflowPage.WorkflowPage, null)
    });
    this.app.router.add('admin.settings.workflow.executions.id', {
      path: '/admin/settings/workflow/executions/:id',
      element: _react().default.createElement(_ExecutionPage.ExecutionPage, null)
    });
  }
}
exports.WorkflowPlugin = WorkflowPlugin;
var _default = WorkflowPlugin;
exports.default = _default;