"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _antdV() {
  const data = require("@formily/antd-v5");
  _antdV = function _antdV() {
    return data;
  };
  return data;
}
function _client() {
  const data = require("@nocobase/client");
  _client = function _client() {
    return data;
  };
  return data;
}
function _client2() {
  const data = require("@nocobase/evaluators/client");
  _client2 = function _client2() {
    return data;
  };
  return data;
}
function _client3() {
  const data = require("@nocobase/utils/client");
  _client3 = function _client3() {
    return data;
  };
  return data;
}
function _antd() {
  const data = require("antd");
  _antd = function _antd() {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _reactI18next() {
  const data = require("react-i18next");
  _reactI18next = function _reactI18next() {
    return data;
  };
  return data;
}
var _FlowContext = require("../FlowContext");
var _RadioWithTooltip = require("../components/RadioWithTooltip");
var _ValueBlock = require("../components/ValueBlock");
var _renderEngineReference = require("../components/renderEngineReference");
var _locale = require("../locale");
var _variable = require("../variable");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function useDynamicExpressionCollectionFieldMatcher(field) {
  var _this$getCollection;
  if (!['belongsTo', 'hasOne'].includes(field.type)) {
    return false;
  }
  if (((_this$getCollection = this.getCollection(field.collectionName)) === null || _this$getCollection === void 0 ? void 0 : _this$getCollection.template) === 'expression') {
    return true;
  }
  const fields = this.getCollectionFields(field.target);
  return fields.some(f => f.interface === 'expression');
}
const DynamicConfig = ({
  value,
  onChange: _onChange
}) => {
  const _useTranslation = (0, _reactI18next().useTranslation)(),
    t = _useTranslation.t;
  const _useCollectionManager = (0, _client().useCollectionManager)(),
    getCollectionFields = _useCollectionManager.getCollectionFields,
    getCollection = _useCollectionManager.getCollection;
  const scope = (0, _variable.useWorkflowVariableOptions)({
    types: [useDynamicExpressionCollectionFieldMatcher.bind({
      getCollectionFields,
      getCollection
    })]
  });
  return _react().default.createElement(_antdV().FormLayout, {
    layout: "vertical"
  }, _react().default.createElement(_antdV().FormItem, {
    colon: true,
    label: t('Expression type', {
      ns: _locale.NAMESPACE
    })
  }, _react().default.createElement(_antd().Radio.Group, {
    value: value === false ? false : value || '',
    onChange: ev => {
      _onChange(ev.target.value);
    }
  }, _react().default.createElement(_antd().Radio, {
    value: false
  }, t('Static', {
    ns: _locale.NAMESPACE
  })), _react().default.createElement(_antd().Radio, {
    value: value || ''
  }, t('Dynamic', {
    ns: _locale.NAMESPACE
  })))), value !== false ? _react().default.createElement(_antdV().FormItem, {
    label: t('Select dynamic expression', {
      ns: _locale.NAMESPACE
    }),
    extra: t('Select the dynamic expression queried from the upstream node. You need to query it from an expression collection.', {
      ns: _locale.NAMESPACE
    })
  }, _react().default.createElement(_client().Variable.Input, {
    value: value || '',
    onChange: v => _onChange(v),
    scope: scope
  })) : null);
};
var _default = {
  title: `{{t("Calculation", { ns: "${_locale.NAMESPACE}" })}}`,
  type: 'calculation',
  group: 'control',
  description: `{{t("Calculate an expression based on a calculation engine and obtain a value as the result. Variables in the upstream nodes can be used in the expression. The expression can be static or dynamic one from an expression collections.", { ns: "${_locale.NAMESPACE}" })}}`,
  fieldset: {
    dynamic: {
      type: 'string',
      'x-component': 'DynamicConfig',
      // description: `{{t("Select the dynamic expression queried from the upstream node. You need to query it from an expression collection.", { ns: "${NAMESPACE}" })}}`,
      default: false
    },
    engine: {
      type: 'string',
      title: `{{t("Calculation engine", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'RadioWithTooltip',
      'x-component-props': {
        options: (0, _client2().getOptions)()
      },
      required: true,
      default: 'math.js',
      'x-reactions': {
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] === false}}'
          }
        }
      }
    },
    expression: {
      type: 'string',
      title: `{{t("Calculation expression", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'CalculationExpression',
      // NOTE: can not use Variable.Input and scope directly as below,
      //       because the scope will be cached.
      // 'x-component': 'Variable.Input',
      // 'x-component-props': {
      //   scope: '{{useWorkflowVariableOptions()}}',
      // },
      ['x-validator'](value, rules, {
        form
      }) {
        const values = form.values;
        const _evaluators$get = _client2().evaluators.get(values.engine),
          evaluate = _evaluators$get.evaluate;
        const exp = value.trim().replace(/{{([^{}]+)}}/g, ' 1 ');
        try {
          evaluate(exp);
          return '';
        } catch (e) {
          return (0, _locale.lang)('Expression syntax error');
        }
      },
      'x-reactions': [{
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0] === false}}'
          }
        }
      }, {
        dependencies: ['engine'],
        fulfill: {
          schema: {
            description: '{{renderEngineReference($deps[0])}}'
          }
        }
      }],
      required: true
    },
    scope: {
      type: 'string',
      title: `{{t("Variable datasource", { ns: "${_locale.NAMESPACE}" })}}`,
      'x-decorator': 'FormItem',
      'x-component': 'ScopeSelect',
      'x-component-props': {
        changeOnSelect: true
      },
      'x-reactions': {
        dependencies: ['dynamic'],
        fulfill: {
          state: {
            visible: '{{$deps[0]}}'
          }
        }
      }
    }
  },
  view: {},
  scope: {
    renderEngineReference: _renderEngineReference.renderEngineReference
  },
  components: {
    CalculationExpression(props) {
      const scope = (0, _variable.useWorkflowVariableOptions)();
      return _react().default.createElement(_client().Variable.TextArea, _objectSpread({
        scope: scope
      }, props));
    },
    ScopeSelect(props) {
      const scope = (0, _variable.useWorkflowVariableOptions)({
        types: [{
          type: 'reference',
          options: {
            collection: '*',
            entity: true
          }
        }]
      });
      return _react().default.createElement(_client().Variable.Input, _objectSpread({
        scope: scope
      }, props));
    },
    CalculationResult({
      dataSource
    }) {
      var _execution$jobs;
      const _useFlowContext = (0, _FlowContext.useFlowContext)(),
        execution = _useFlowContext.execution;
      if (!execution) {
        return (0, _locale.lang)('Calculation result');
      }
      const result = (0, _client3().parse)(dataSource)({
        $jobsMapByNodeId: ((_execution$jobs = execution.jobs) !== null && _execution$jobs !== void 0 ? _execution$jobs : []).reduce((map, job) => Object.assign(map, {
          [job.nodeId]: job.result
        }), {})
      });
      return _react().default.createElement("pre", {
        className: (0, _client().css)`
            margin: 0;
          `
      }, JSON.stringify(result, null, 2));
    },
    RadioWithTooltip: _RadioWithTooltip.RadioWithTooltip,
    DynamicConfig
  },
  useVariables({
    id,
    title
  }, {
    types,
    fieldNames = _client().defaultFieldNames
  }) {
    if (types && !types.some(type => type in _variable.BaseTypeSets || Object.values(_variable.BaseTypeSets).some(set => set.has(type)))) {
      return null;
    }
    return {
      [fieldNames.value]: `${id}`,
      [fieldNames.label]: title
    };
  },
  useInitializers(node) {
    var _node$title;
    return {
      type: 'item',
      title: (_node$title = node.title) !== null && _node$title !== void 0 ? _node$title : `#${node.id}`,
      component: _ValueBlock.ValueBlock.Initializer,
      node,
      resultTitle: (0, _locale.lang)('Calculation result')
    };
  }
};
exports.default = _default;