"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _server() {
  const data = require("@nocobase/server");
  _server = function _server() {
    return data;
  };
  return data;
}
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function findSchema(root, filter, onlyLeaf = false) {
  const result = [];
  if (!root) {
    return result;
  }
  if (filter(root) && (!onlyLeaf || !root.properties)) {
    result.push(root);
    return result;
  }
  if (root.properties) {
    Object.keys(root.properties).forEach(key => {
      result.push(...findSchema(root.properties[key], filter));
    });
  }
  return result;
}
function migrateConfig(config) {
  const _config$forms = config.forms,
    forms = _config$forms === void 0 ? {} : _config$forms,
    _config$schema = config.schema,
    schema = _config$schema === void 0 ? {} : _config$schema;
  const root = {
    properties: schema
  };
  Object.keys(forms).forEach(key => {
    const form = forms[key];
    const formSchema = findSchema(root, item => item.name === key);
    const actions = findSchema(formSchema[0], item => item['x-component'] === 'Action');
    form.actions = actions.map(action => {
      action['x-designer'] = 'ManualActionDesigner';
      action['x-action-settings'] = {};
      delete action['x-action'];
      return {
        status: action['x-decorator-props'].value,
        values: {},
        key: action.name
      };
    });
  });
  return config;
}
class _default extends _server().Migration {
  up() {
    var _this = this;
    return _asyncToGenerator(function* () {
      const match = yield _this.app.version.satisfies('<0.11.0-alpha.2');
      if (!match) {
        return;
      }
      const db = _this.context.db;
      const NodeRepo = db.getRepository('flow_nodes');
      yield db.sequelize.transaction( /*#__PURE__*/function () {
        var _ref = _asyncToGenerator(function* (transaction) {
          const nodes = yield NodeRepo.find({
            filter: {
              type: 'manual'
            },
            transaction
          });
          console.log('%d nodes need to be migrated.', nodes.length);
          yield nodes.reduce((promise, node) => promise.then(() => {
            node.set('config', _objectSpread({}, migrateConfig(node.config)));
            node.changed('config', true);
            return node.save({
              silent: true,
              transaction
            });
          }), Promise.resolve());
        });
        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }());
    })();
  }
}
exports.default = _default;